﻿package net.delaunay
{
	//Credit to Paul Bourke (pbourke@swin.edu.au) for the original Fortran 77 Program :))
	//Converted to a standalone C# 2.0 library by Morten Nielsen (www.iter.dk)
	//Check out: http://astronomy.swin.edu.au/~pbourke/terrain/triangulate/
	//You can use this code however you like providing the above credits remain in tact

	import net.delaunay.DelaunayPoint;
	import flash.geom.Point;

	public class Triangle 
	{
		//points of the triangle
		public var p1:DelaunayPoint;
		public var p2:DelaunayPoint;
		public var p3:DelaunayPoint;
		
		//gravity center
		public var center:DelaunayPoint;
		
		//middle of the sides
		public var mid0:DelaunayPoint;//p0 > p1
		public var mid1:DelaunayPoint;//p1 > p2
		public var mid2:DelaunayPoint;//p2 > p0
		
		public function Triangle( p1:DelaunayPoint, p2:DelaunayPoint, p3:DelaunayPoint )
		{
		
			this.p1 = p1;
			this.p2 = p2;
			this.p3 = p3;
			
		}
		
		/**
		 * retrieves the gravity center of the triangle
		 */
		public function getCenter():Point
		{
			
			if( center == null ) center = new DelaunayPoint( 0,0 );
			center.x = ( p1.x + p2.x + p3.x ) / 3;
			center.y = ( p1.y + p2.y + p3.y ) / 3;
			
			return new Point(center.x, center.y);
			
		}
		
		/**
		 * retrieves the midPoint of the triangle's sides. might be useful in some cases
		*/
		public function getSidesCenters():void
		{
			if( mid0 == null || mid1 == null || mid2 == null )
			{
				mid0 = new DelaunayPoint( 0, 0 );
				mid1 = new DelaunayPoint( 0, 0 );
				mid2 = new DelaunayPoint( 0, 0 );
			} 
			
			mid0.x = p1.x + ( p2.x - p1.x )/2;
			mid0.y = p1.y + ( p2.y - p1.y )/2;
			
			mid1.x = p2.x + ( p3.x - p2.x )/2;
			mid1.y = p2.y + ( p3.y - p2.y )/2;	
			
			mid2.x = p3.x + ( p1.x - p3.x )/2;
			mid2.y = p3.y + ( p1.y - p3.y )/2;
		}
		
	}
}
